Description

We need a way to distinguish between fields that were explicitly provided in JSON requests and fields that were omitted entirely. We
used to use pointers to identify this but using generics we can design a simple solution. Optional[T] type with a custom unmarshaler
can correctly detects when a field is provided vs not provided in JSON and provide simple way to identify and get the value correctly
compared to handling pointers.

Associated revisions

Revision e0b93931 - 06/05/2025 01:26 AM - Sachin Divekar
Add Optional type to handle optional values in JSON requests #27243
This adds a generic Optional type to the wscutils package that helps distinguish between fields that were explicitly provided in a JSON request (even

with zero values) and fields that were not provided at all. It tracks field presence, handles null values, and provides a convenient Get() method for
safely accessing values.

History

#1 - 05/05/2025 11:52 PM - Sachin Divekar

- Status changed from New to In Progress

#2 - 06/05/2025 08:32 AM - Sachin Divekar

Added a generic Optional type to the wscutils package that helps distinguish between fields that were explicitly provided in a JSON request (even with
zero values) and fields that were not provided at all. It tracks field presence, handles null values, and provides a convenient Get() method for safely
accessing values.

e Written tests
¢ Written examples and tutorial

#3 - 06/05/2025 08:32 AM - Sachin Divekar

- Status changed from In Progress to Testing

#4 - 06/05/2025 08:32 AM - Sachin Divekar

- Status changed from Testing to Closed
